<?php

$author = array(1 => 'Christopher Paolini');
$publisher = array(1=>array('name'=>'Knopf Books for young readers'));
$books = array(
	array('date'=>'August 26, 2003',
		'publisher'=>'1',
		'pages'=>'544',
		'author'=>'1',
		'title'=>'Eragon (Inheritance, Book 1)'),
	array('date'=>'August 23, 2005',
		'publisher'=>'1',
		'pages'=>'704',
		'author'=>'1',
		'title'=>'Eldest (Inheritance, Book 2)'),
	);
	
$w = new XMLWriter();
//$w->openURI($argv[1]);
$w->openMemory();
$w->setIndent(true);
$w->setIndentString('  ');
$w->startDocument('1.0', 'UTF-8');

$w->startElement('books');

foreach($author as $id => $name) {
	$w->startElement('author');
	$w->writeAttribute('id', $id);
	$w->text($name);
	$w->endElement();
}

foreach($publisher as $id => $name)
{
	$w->startElement('publisher');
	$w->writeAttribute('id', $id);
	$w->writeAttribute('name', $name);
	$w->endElement();
}

foreach($books as $book)
{
	$w->startElement('book');
	foreach($book as $attr => $val)
	{
		if ($attr != 'title') {
			$w->writeAttribute($attr, $val);
		}
	}
	$w->text($book['title']);
	$w->endElement();
}

$w->endDocument();

echo $w->outputMemory();

?>